//
//  BleWrapper.h
//  BleWrapper
//
//  Created by etek on 18/8/28.
//  Copyright (c) 2018年 ETEK. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BleDevice.h"
#import "DevData.h"
#import "BTInfo.h"



enum BTState {
    BTState_Connectting = 1,
    BTState_Connected = 2,
    BTState_Disconnect = 4,
    BTState_DeviceOk = 7,
};

@protocol BleWrapperDelegate <NSObject>
- (void)onRecieviceData:(DevData*)data;
- (void)onWriteDataOk:(DevData*)data;
- (void)onFoundNewBleDev:(ScanInfo*)info;
- (void)onBTConnectState:(CBPeripheral*)peri state:(int)state;
- (void)onBTMacInfo:(DevData*)data;
@end


// 蓝牙灯
//#define USER_SERVICE @"0000E0FF-3C17-D293-8E48-14FE2E4DA212"
//#define USER_WRITE   @"FFE1"
//#define USER_READ    @"FFE1"

// 标准设备(默认设置)
#define USER_SERVICE @"FFF0"
#define USER_WRITE   @"FFF1"
#define USER_READ    @"FFF2"

@interface BleWrapper : NSObject

@property (nonatomic, weak) id <BleWrapperDelegate> mDelegate;

// connect ble deivce
- (Boolean) connectBleDevice:(int)index;
// disconnect ble device
- (Boolean) disconnectBleDevice:(int)index;
// send data to ble
- (Boolean) sendDataToBleById:(int)index buffer:(Byte*)data lenght:(int)lenght;
// start scan ble device
- (void) StartScan;
// stop scan ble device
- (void) StopScan;
// set ble uuid: service, read, write
- (void) setUserUuid:(NSString*)service readUuid:(NSString*)readUuid writeUuid:(NSString*)writeUuid;
// get device list
- (NSMutableArray*) getBTDevArrays;
// get device index of device list
- (int) getBTDeviceIndex:(CBPeripheral*)peri;
// get device info
- (BTInfo*) getBTDevice:(CBPeripheral*)peri;
- (BTInfo*) getBTDeviceByIndex:(int)index;

@end
